#include <linux/if.h>
#include <linux/if_tun.h>

#include <unistd.h>
#include <fcntl.h>
#include <sys/ioctl.h>

#include <stdio.h>
#include <string.h>

#include "tundev.h"

int tundev_open(char *dev)
{
	int tunfd = open("/dev/net/tun", O_RDWR);
	if(tunfd < 0) {
		perror("tundev: open");
		return -1;
	}

	struct ifreq ifr;
	memset(&ifr, 0, sizeof(ifr));

	ifr.ifr_flags = IFF_TUN | IFF_NO_PI;

	strncpy(ifr.ifr_name, dev, IFNAMSIZ);

	int ret = ioctl(tunfd, TUNSETIFF, &ifr);
	if(ret < 0) {
		perror("tundev: ioctl");
		goto error;
	}

	strcpy(dev, ifr.ifr_name);

	fprintf(stderr, "tundev: Successfully allocated tun device %s\n", dev);

	return tunfd;


	fprintf(stderr, "tundev: Closing device.\n");

	close(tunfd);
	return 0;

error:
	close(tunfd);
	return -1;
}


result_t tundev_close(int tundev)
{
	if(close(tundev) < 0) {
		return ERR_SYSCALL;
	} else {
		return OK;
	}
}


result_t tundev_read_loop(int tunfd, tundev_read_callback_t callback)
{
	uint8_t buf[2048];
	int ret;

	do {
		ret = read(tunfd, buf, sizeof(buf));

		if(ret <= 0) {
			break;
		}

		fprintf(stderr, "tundev: Read %d bytes from tun device.\n", ret);
	} while(callback(buf, ret));

	if(ret == 0) {
		fprintf(stderr, "tundev: no more data.\n");
		return OK;
	} else {
		perror("tundev: read");
		return ERR_SYSCALL;
	}
}
